/***********************************************************************/
/*                                                                     */
/*       Programs written by Xin Zhang                                 */
/*       Courant Institute of Mathematical Science                     */
/*       Department of Computer Science                                */
/*       New York University                                           */
/*                                                                     */
/*       Programs modified by Yang Song                                */
/*       Department of Computer Science                                */
/*       New Jersey Institute of Technology                            */
/*       University Heights, Newark, NJ 07102, USA                     */
/*       RA in the group of Dr. Jason T. L. Wang (NJIT)                */
/*                                                                     */
/*	 Permission to use, copy, modify, and distribute this    	       */
/*	 software and its documentation for any purpose and without        */
/*	 fee is hereby granted, provided that this copyright	           */
/*	 notice appears in all copies.   Programmer(s) makes no	           */
/*	 representations about the suitability of this		               */
/*	 software for any purpose.  It is provided "as is" without         */
/*	 express or implied warranty.				                       */
/*                                                                     */
/***********************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <fstream>
#include <iostream>
#include "SAT.h"
#include "SATFinder.h"
#include "string.h"

#pragma warning(disable:4768)


void searchSAT(int argc, char* argv[])
{
	int maxNumStates = 500;

	if (argc == 6)
		maxNumStates = atoi(argv[5]); /*
	{
		frontierSize = atoi(argv[5]);
		numFinalNodes = atoi(argv[5]);
	}*/

	SATFinder finder;
	finder.setSearchParam(maxNumStates, maxNumStates);
	finder.searchSAT(argv[2], argv[3], argv[4]);
}


void detectPeak(int argc, char* argv[])
{
	SAT sat;
	sat.readStruct(argv[4], argv[2]);
	sat.incrementalDetect(argv[3]);
}

void dynamicDetectPeak(int argc, char* argv[])
{
	SAT sat;
	sat.readStruct(argv[4], argv[2]);
	sat.incrementalDynamicDetect(argv[3]);
}


int main(int argc, char* argv[])
{
	if (argc != 5 && argc != 6)
	{
		printf("Usage: SAT option ThresholdFile InputDataFile SatFile [maxNumStates] \n");
		printf("option = 1: to train the Shifted Aggregation Tree from the InputDataFile \n");
		printf("option = 2 or 3: to detect the peaks in the InputDataFile \n");
		return 0;
	}

	if (!strcmp(argv[1], "1"))
		searchSAT(argc, argv);
	else if (!strcmp(argv[1], "2"))
		detectPeak(argc, argv);
	else if (!strcmp(argv[1], "3"))
		dynamicDetectPeak(argc, argv);
	else
	{
		printf("Usage: SAT option ThresholdFile InputDataFile SatFile [maxNumStates] \n");
		printf("option = 1: to train the Shifted Aggregation Tree from the InputDataFile \n");
		printf("option = 2 or 3: to detect the peaks in the InputDataFile \n");
		return 0;
	}
	return 0;
}
